Package org.jcsp.awt

# Class ActiveScrollbar

java.lang.Object
java.awt.Component
java.awt.Scrollbar
org.jcsp.awt.ActiveScrollbar

All Implemented Interfaces:
  `Adjustable`, `ImageObserver`, `MenuContainer`, `Serializable`, `Accessible`, `CSProcess`

public class ActiveScrollbar extends Scrollbar implements CSProcess
``java.awt.Scrollbar`` with a channel interface.

## Process Diagram

## Description

`ActiveScrollbar` is a process extension of `java.awt.Scrollbar` with channels for run-time configuration and event notification. The event channels should be connected to one or more application-specific server processes (instead of registering a passive object as a Listener to this component).

All channels are optional. The `configure` and `event` channels are settable from a constructor. The `event` channel delivers the adjusted value whenever the `ActiveScrollbar` is moved. Other event channels can be added to notify the occurrence of any other events the component generates (by calling the appropriate `add` XXX `EventChannel` method before the process is run). Messages can be sent down the `configure` channel at any time to configure the component. See the table below for details.

All channels are managed by independent internal handler processes. It is, therefore, safe for a serial application process both to service an event channel and configure the component -- no deadlock can occur.

IMPORTANT: it is essential that event channels from this process are always serviced -- otherwise the Java Event Thread will be blocked and the GUI will stop responding. A simple way to guarantee this is to use channels configured with overwriting buffers. For example:

       final One2OneChannelInt myScrollbarEvent = Channel.one2oneInt (new OverWriteOldestBuffer (n));

       final ActiveScrollbar myScrollbar =
         new ActiveScrollbar (null, myScrollbarEvent.out (), Scrollbar.HORIZONTAL, 0, 10, 0, 110);

This will ensure that the Java Event Thread will never be blocked. Slow or inattentive readers may miss rapidly generated events, but the `n` most recent events will always be available.

## Channel Protocols

Input Channels
configure | Integer | Sets the value of the scrollbar to the value received

Boolean

1. If this is the `Boolean.TRUE` object, the scrollbar is made active
2. If this is the `Boolean.FALSE` object, the scrollbar is made inactive
3. Other `Boolean` objects are ignored

ActiveScrollbar.Configure | Invoke the user-defined `Configure.configure` method on the scrollbar.
Output Channels
event | int | The new value of the scrollbar
componentEvent | ComponentEvent | See the ``addComponentEventChannel`` method.
focusEvent | FocusEvent | See the ``addFocusEventChannel`` method.
keyEvent | KeyEvent | See the ``addKeyEventChannel`` method.
mouseEvent | MouseEvent | See the ``addMouseEventChannel`` method.
mouseMotionEvent | MouseEvent | See the ``addMouseMotionEventChannel`` method.

## Example

     import java.awt.*;
     import java.awt.event.*;
     import org.jcsp.lang.*;
     import org.jcsp.util.ints.*;
     import org.jcsp.awt.*;

     public class ActiveScrollbarExample {

       public static void main (String argv[]) {

         final ActiveClosingFrame activeFrame = new ActiveClosingFrame ("ActiveScrollbar Example");

         final One2OneChannel configure = Channel.one2one ();
         final One2OneChannelInt scrollEvent = Channel.one2oneInt (new OverWriteOldestBufferInt (10));

         final ActiveScrollbar scrollBar =
           new ActiveScrollbar (
             null, scrollEvent.out (), Scrollbar.HORIZONTAL, 0, 10, 0, 110
           );

         final Frame realFrame = activeFrame.getActiveFrame ();
         realFrame.setSize (400, 75);
         realFrame.add (scrollBar);
         realFrame.setVisible (true);

         new Parallel (
           new CSProcess[] {
             activeFrame,
             scrollBar,
             new CSProcess () {
               public void run () {
                 final long FREE_TIME = 10000, BUSY_TIME = 250;
                 CSTimer tim = new CSTimer ();
                 Alternative alt = new Alternative (new Guard[] {tim, scrollEvent.in ()});
                 final int TIM = 0, SCROLL = 1;
                 long timeout = tim.read ();
                 tim.setAlarm (timeout + FREE_TIME);
                 boolean running = true;
                 while (running) {
                   switch (alt.priSelect ()) {
                     case TIM:                                     // timeout happened
                       configure.out ().write (Boolean.FALSE);     // disable scrollbar
                       for (int i = 40; i > 0; i--) {
                         System.out.println ("*** busy busy busy ... " + i);
                         timeout = tim.read ();
                         tim.after (timeout + BUSY_TIME);
                       }
                       System.out.println ("*** free free free ... 0");
                       configure.out ().write (Boolean.TRUE);      // enable scrollbar
                       timeout = tim.read ();
                       tim.setAlarm (timeout + FREE_TIME);
                     break;
                     case SCROLL:                                  // scrollEvent happened
                       int position = scrollEvent.in ().read ();
                       System.out.println ("ScrollBar ==> " + position);
                       running = (position != 100);
                     break;
                   }
                 }
                 realFrame.setVisible (false);
                 System.exit (0);
               }
             }
           }
         ).run ();
       }

     }

Author:
  P.D. Austin and P.H. Welch
See Also:
  - `Scrollbar`
  - `ComponentEvent`
  - `FocusEvent`
  - `KeyEvent`
  - `MouseEvent`
  - `OverWriteOldestBuffer`
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static interface`
`ActiveScrollbar.Configure`
This enables general configuration of this component.

## Nested classes/interfaces inherited from class java.awt.Scrollbar

`Scrollbar.AccessibleAWTScrollBar`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

### Fields inherited from class java.awt.Scrollbar

`HORIZONTAL, VERTICAL`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.Adjustable

`NO_ORIENTATION`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`ActiveScrollbar()`
Constructs a vertical `ActiveScrollbar` with no configuration or event channels.
`ActiveScrollbar(int orientation)`
Constructs a `ActiveScrollbar` with the specified orientation, but still with no configuration or event channels.
`ActiveScrollbar(int orientation, int value, int visible, int minimum, int maximum)`
Constructs a `ActiveScrollbar` with all its options, but still with no configuration or event channels.
`ActiveScrollbar(ChannelInput configure, ChannelOutputInt event)`
Constructs a vertical `ActiveScrollbar` with configuration and event channels.
`ActiveScrollbar(ChannelInput configure, ChannelOutputInt event, int orientation)`
Constructs a `ActiveScrollbar` with configuration and event channels and the specified orientation.
`ActiveScrollbar(ChannelInput configure, ChannelOutputInt event, int orientation, int value, int visible, int minimum, int maximum)`
Constructs a `ActiveScrollbar` with configuration and event channels and all its options.

## Method Summary

Modifier and Type
Method
Description
`void`
`addComponentEventChannel(ChannelOutput componentEvent)`
Add a new channel to this component that will be used to notify that a `ComponentEvent` has occurred.
`void`
`addFocusEventChannel(ChannelOutput focusEvent)`
Add a new channel to this component that will be used to notify that a `FocusEvent` has occurred.
`void`
`addKeyEventChannel(ChannelOutput keyEvent)`
Add a new channel to this component that will be used to notify that a `KeyEvent` has occurred.
`void`
`addMouseEventChannel(ChannelOutput mouseEvent)`
Add a new channel to this component that will be used to notify that a `MouseEvent` has occurred.
`void`
`addMouseMotionEventChannel(ChannelOutput mouseMotionEvent)`
Add a new channel to this component that will be used to notify that a `MouseMotionEvent` has occurred.
`void`
`run()`
The main body of this process.
`void`
`setConfigureChannel(ChannelInput configure)`
Sets the configuration channel for this `ActiveScrollbar`.

### Methods inherited from class java.awt.Scrollbar

`addAdjustmentListener, addNotify, getAccessibleContext, getAdjustmentListeners, getBlockIncrement, getLineIncrement, getListeners, getMaximum, getMinimum, getOrientation, getPageIncrement, getUnitIncrement, getValue, getValueIsAdjusting, getVisible, getVisibleAmount, paramString, processAdjustmentEvent, processEvent, removeAdjustmentListener, setBlockIncrement, setLineIncrement, setMaximum, setMinimum, setOrientation, setPageIncrement, setUnitIncrement, setValue, setValueIsAdjusting, setValues, setVisibleAmount`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, deliverEvent, disable, disableEvents, dispatchEvent, doLayout, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAlignmentX, getAlignmentY, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentAt, getComponentAt, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeys, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocation, getLocationOnScreen, getMaximumSize, getMinimumSize, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPreferredSize, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, invalidate, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusCycleRoot, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, layout, list, list, list, list, list, locate, location, lostFocus, minimumSize, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paint, paintAll, postEvent, preferredSize, prepareImage, prepareImage, print, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, requestFocusInWindow, reshape, resize, resize, revalidate, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeys, setFocusTraversalKeysEnabled, setFont, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setMixingCutoutShape, setName, setPreferredSize, setSize, setSize, setVisible, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle, update, validate`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ActiveScrollbar

public ActiveScrollbar()
Constructs a vertical `ActiveScrollbar` with no configuration or event channels.

### ActiveScrollbar

public ActiveScrollbar(int orientation)
Constructs a `ActiveScrollbar` with the specified orientation, but still with no configuration or event channels. The minimum and maximum values default to 0 and 100, with the initial setting at 0.

Parameters:
  `orientation` - indicates the orientation of the scroll bar (Scrollbar.VERTICAL, Scrollbar.HORIZONTAL).

### ActiveScrollbar

public ActiveScrollbar(int orientation, int value, int visible, int minimum, int maximum)
Constructs a `ActiveScrollbar` with all its options, but still with no configuration or event channels.

Parameters:
  `orientation` - indicates the orientation of the scroll bar (Scrollbar.VERTICAL, Scrollbar.HORIZONTAL).
  `value` - the initial value of the scroll bar.
  `visible` - the size of the scroll bar's bubble, representing the visible portion; the scroll bar uses this value when paging up or down by a page.
  `minimum` - the minimum value of the scroll bar.
  `maximum` - the maximum value of the scroll bar.

### ActiveScrollbar

public ActiveScrollbar(ChannelInput configure, ChannelOutputInt event)
Constructs a vertical `ActiveScrollbar` with configuration and event channels. The minimum and maximum values default to 0 and 100, with the initial setting at 0.

Parameters:
  `configure` - the channel for configuration events -- can be null if no configuration is required.
  `event` - the adjusted value will be output when the scrollbar is moved -- can be null if no notification is required.

### ActiveScrollbar

public ActiveScrollbar(ChannelInput configure, ChannelOutputInt event, int orientation)
Constructs a `ActiveScrollbar` with configuration and event channels and the specified orientation. The minimum and maximum values default to 0 and 100, with the initial setting at 0.

Parameters:
  `configure` - the channel for configuration events -- can be null if no configuration is required.
  `event` - the adjusted value will be output when the scrollbar is moved -- can be null if no notification is required.
  `orientation` - indicates the orientation of the scroll bar (Scrollbar.VERTICAL, Scrollbar.HORIZONTAL).

### ActiveScrollbar

public ActiveScrollbar(ChannelInput configure, ChannelOutputInt event, int orientation, int value, int visible, int minimum, int maximum)
Constructs a `ActiveScrollbar` with configuration and event channels and all its options.

Parameters:
  `configure` - the channel for configuration events -- can be null if no configuration is required.
  `event` - the adjusted value will be output when the scrollbar is moved -- can be null if no notification is required.
  `orientation` - indicates the orientation of the scroll bar (Scrollbar.VERTICAL, Scrollbar.HORIZONTAL).
  `value` - the initial value of the scroll bar.
  `visible` - the size of the scroll bar's bubble, representing the visible portion; the scroll bar uses this value when paging up or down by a page.
  `minimum` - the minimum value of the scroll bar.
  `maximum` - the maximum value of the scroll bar.

## Method Details

### setConfigureChannel

public void setConfigureChannel(ChannelInput configure)
Sets the configuration channel for this `ActiveScrollbar`. This method overwrites any configuration channel set in the constructor.

Parameters:
  `configure` - the channel for configuration events -- can be null if no configuration is required.

### addComponentEventChannel

public void addComponentEventChannel(ChannelOutput componentEvent)
Add a new channel to this component that will be used to notify that a `ComponentEvent` has occurred. This should be used instead of registering a ComponentListener with the component. It is possible to add more than one channel by calling this method multiple times If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `componentEvent` - the channel down which to send ComponentEvents.

### addFocusEventChannel

public void addFocusEventChannel(ChannelOutput focusEvent)
Add a new channel to this component that will be used to notify that a `FocusEvent` has occurred. This should be used instead of registering a FocusListener with the component. It is possible to add more than one channel by calling this method multiple times If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `focusEvent` - the channel down which to send FocusEvents.

### addKeyEventChannel

public void addKeyEventChannel(ChannelOutput keyEvent)
Add a new channel to this component that will be used to notify that a `KeyEvent` has occurred. This should be used instead of registering a KeyListener with the component. It is possible to add more than one channel by calling this method multiple times If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `keyEvent` - the channel down which to send KeyEvents.

### addMouseEventChannel

public void addMouseEventChannel(ChannelOutput mouseEvent)
Add a new channel to this component that will be used to notify that a `MouseEvent` has occurred. This should be used instead of registering a MouseListener with the component. It is possible to add more than one channel by calling this method multiple times If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `mouseEvent` - the channel down which to send MouseEvents.

### addMouseMotionEventChannel

public void addMouseMotionEventChannel(ChannelOutput mouseMotionEvent)
Add a new channel to this component that will be used to notify that a `MouseMotionEvent` has occurred. This should be used instead of registering a MouseMotionListener with the component. It is possible to add more than one channel by calling this method multiple times If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `mouseMotionEvent` - the channel down which to send MouseMotionEvents.

### run

public void run()
The main body of this process.

Specified by:
  `run` in interface `CSProcess`